﻿Option Strict On
Option Explicit On

Imports VBN_TaskDialog.Dialog

Public Class Form1

    Private ReadOnly StdTaskDialog As New TaskDialog
    Private WithEvents EvtTaskDialog As New TaskDialog
    Private WithEvents PageTaskDialog As New TaskDialog

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        ' Zeigt alle Standardcontrols auf dem TaskDialog (ohne Events)
        Dim DialogPage As New TaskDialogPage

        With DialogPage
            .DialogFlags = TaskDialogPage.TaskDialogFlags.ShowProgressBar Or
                           TaskDialogPage.TaskDialogFlags.UseCommandLinks
            .DialogTitle = "Title"
            .DialogInstruction = "Instruction"
            .DialogContent = "Content"
            .DialogVerificationText = "VerificationText"
            .DialogExpandedControlText = "ExpandedControlText"
            .DialogExpandedInformation = "ExpandedInformation"
            .DialogCollapsedControlText = "CollapsedControlText"
            .DialogFooterText = "FooterText"
            .DialogCommonMainIcon = TaskDialogPage.TaskDialogIcon.ShieldSuccessGreenBar
            .DialogCommonFooterIcon = TaskDialogPage.TaskDialogIcon.Information
            .DialogAddButton = New TaskDialogButton(TaskDialogButton.TaskDialogButtons.Ok)
            .DialogAddButton = New TaskDialogButton(TaskDialogButton.TaskDialogButtons.Cancel)
            .DialogAddButton = New TaskDialogButton(101, "CommandLink 1")
            .DialogAddButton = New TaskDialogButton(102, "CommandLink 2")
            .DialogAddRadioButton = New TaskDialogRadioButton(201, "RadioButton 1")
            .DialogAddRadioButton = New TaskDialogRadioButton(202, "RadioButton 2")
            .DialogProgressBarRange = New TaskDialogPage.TaskDialogProgressBarRange(0, 100)
            .DialogProgressBarValue = 50
        End With

        Debug.Print("TaskDialog return: " & StdTaskDialog.Show(Me, DialogPage).ToString)
        Debug.Print("TaskDialog GetSelectedRadioButton: " & StdTaskDialog.DialogGetSelectedRadioButton.ToString)
        Debug.Print("TaskDialog IsVerificationChecked: " & StdTaskDialog.DialogIsVerificationChecked.ToString)

    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click

        ' Zeigt benutzerdefinierte Buttons auf dem TaskDialog (ohne Events)
        Dim DialogPage As New TaskDialogPage

        With DialogPage
            .DialogFlags = TaskDialogPage.TaskDialogFlags.Default
            .DialogTitle = "Benutzerdefinierte Buttons"
            .DialogInstruction = "Instruction"
            .DialogContent = "Content"
            .DialogCommonMainIcon = TaskDialogPage.TaskDialogIcon.ShieldBlueBar
            .DialogAddButton = New TaskDialogButton(101, "Button 1")
            .DialogAddButton = New TaskDialogButton(102, "Button 2")
            .DialogAddButton = New TaskDialogButton(103, "Button 3")
        End With

        Debug.Print("TaskDialog return: " & StdTaskDialog.Show(Me, DialogPage).ToString)

    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click

        Using UserIcon As New Icon(My.Resources.User, 16, 16)
            Using StarIcon As New Icon(My.Resources.Star, 16, 16)
                Using QuestionIcon As New Icon(My.Resources.Question, 16, 16)

                    ' Zeigt benutzerdefinierte Icons auf dem TaskDialog und Buttons (ohne Events)
                    Dim DialogPage As New TaskDialogPage

                    With DialogPage
                        .DialogFlags = TaskDialogPage.TaskDialogFlags.UseCommandLinks Or
                                       TaskDialogPage.TaskDialogFlags.AllowDialogCancellation Or
                                       TaskDialogPage.TaskDialogFlags.UseMainIconHandle Or
                                       TaskDialogPage.TaskDialogFlags.UseFooterIconHandle

                        .DialogTitle = "Benutzerdefinierte Icons"
                        .DialogInstruction = "Instruction"
                        .DialogContent = "Content"
                        .DialogVerificationText = "VerificationText"
                        .DialogExpandedControlText = "ExpandedControlText"
                        .DialogExpandedInformation = "ExpandedInformation"
                        .DialogCollapsedControlText = "CollapsedControlText"
                        .DialogFooterText = "FooterText"

                        .DialogIconHandle = My.Resources.YellowShield.Handle
                        .DialogMainIconHandle = My.Resources.Defrag.Handle
                        .DialogFooterIconHandle = My.Resources.Settings.Handle
                        .DialogAddButton = New TaskDialogButton(TaskDialogButton.TaskDialogButtons.Close,,,, True)
                        .DialogAddButton = New TaskDialogButton(TaskDialogButton.TaskDialogButtons.Yes,,,,, UserIcon.Handle)
                        .DialogAddButton = New TaskDialogButton(TaskDialogButton.TaskDialogButtons.No,,,,, StarIcon.Handle)
                        .DialogAddButton = New TaskDialogButton(101, "CommandLink 1",,,, True)
                        .DialogAddButton = New TaskDialogButton(102, "CommandLink 2",,,,, QuestionIcon.Handle)
                    End With

                    Debug.Print("TaskDialog return: " & StdTaskDialog.Show(Me, DialogPage).ToString)

                End Using
            End Using
        End Using

    End Sub

    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click

        Using UserIcon As New Icon(My.Resources.User, 32, 32)

            ' Zeigt Hyperlinks auf dem TaskDialog (mit Events)
            Dim DialogPage As New TaskDialogPage

            With DialogPage
                .DialogFlags = TaskDialogPage.TaskDialogFlags.EnableHyperlinks Or
                               TaskDialogPage.TaskDialogFlags.UseMainIconHandle

                .DialogTitle = "Hyperlinks"
                .DialogInstruction = "Such Dir einen Link aus..."
                .DialogContent = "Hier geht es zu <a href=""https://www.google.com/search?q=TaskDialog"">Google</a> oder direkt " &
                                 "zur <a href=""https://docs.microsoft.com/en-us/windows/win32/controls/task-dialogs"">Microsoft Doku</a> um " &
                                 "mehr zum TaskDialog zu erfahren."
                .DialogMainIconHandle = UserIcon.Handle
            End With

            Debug.Print("TaskDialog return: " & EvtTaskDialog.Show(Me, DialogPage).ToString)

        End Using

    End Sub

    Private Sub EvtTaskDialog_DialogHyperlinkClicked(hDialog As IntPtr, Hyperlink As String) Handles EvtTaskDialog.DialogHyperlinkClicked
        Process.Start(Hyperlink)
    End Sub

    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click

        ' Verification Sample (mit Events)
        Dim DialogPage As New TaskDialogPage

        With DialogPage
            .DialogFlags = TaskDialogPage.TaskDialogFlags.Default
            .DialogTitle = "Verification"
            .DialogInstruction = "Lizenz"
            .DialogContent = "Lizenzbestimmungen ..."
            .DialogVerificationText = "Ich habe die Lizenzbestimmungen gelesen und stimme diesen zu."
            .DialogCommonMainIcon = TaskDialogPage.TaskDialogIcon.ShieldSuccessGreenBar
            .DialogCommonFooterIcon = TaskDialogPage.TaskDialogIcon.Information
            .DialogAddButton = New TaskDialogButton(TaskDialogButton.TaskDialogButtons.Continue,, False)
        End With

        Debug.Print("TaskDialog return: " & EvtTaskDialog.Show(Me, DialogPage).ToString)
    End Sub

    Private Sub EvtTaskDialog_DialogVerificationClicked(hDialog As IntPtr, Checked As Boolean) Handles EvtTaskDialog.DialogVerificationClicked
        EvtTaskDialog.DialogEnableButton(TaskDialogButton.TaskDialogButtons.Continue, Checked)
    End Sub

    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles Button6.Click

        ' Button Disable Close Dialog Sample (mit Events)
        Dim DialogPage As New TaskDialogPage

        With DialogPage
            .DialogFlags = TaskDialogPage.TaskDialogFlags.Default
            .DialogTitle = "Disable Close Dialog"
            .DialogInstruction = "Instruction"
            .DialogContent = "Content"
            .DialogCommonMainIcon = TaskDialogPage.TaskDialogIcon.ShieldBlueBar
            .DialogAddButton = New TaskDialogButton(101, "Hier kommst Du nicht raus. ;-)",,, False)
            .DialogAddButton = New TaskDialogButton(TaskDialogButton.TaskDialogButtons.Ok)
        End With

        Debug.Print("TaskDialog return: " & EvtTaskDialog.Show(Me, DialogPage).ToString)
    End Sub

    Private Sub EvtTaskDialog_DialogButtonClicked(hDialog As IntPtr, ButtonID As TaskDialog.TaskDialogResult) Handles EvtTaskDialog.DialogButtonClicked
        If ButtonID = 101 Then MessageBox.Show("Netter Versuch, aber hier kommst Du nicht raus. :-P")
    End Sub

    Private Sub Button7_Click(sender As Object, e As EventArgs) Handles Button7.Click

        ' TaskDialog Timer Sample (mit Events)
        Dim DialogPage As New TaskDialogPage

        With DialogPage
            .DialogFlags = TaskDialogPage.TaskDialogFlags.ShowProgressBar Or
                           TaskDialogPage.TaskDialogFlags.CallbackTimer
            .DialogTitle = "Timer Sample & Auto Close"
            .DialogInstruction = "Bitte warten...."
            .DialogFooterText = "Dieser Dialog beendet sich in 10 Sekunden selbst."
            .DialogAddButton = New TaskDialogButton(101, "Hier kommst Du nicht raus. ;-)",,, False)
            .DialogCommonMainIcon = TaskDialogPage.TaskDialogIcon.ShieldSuccessGreenBar
            .DialogProgressBarRange = New TaskDialogPage.TaskDialogProgressBarRange(0, 100)
        End With

        Debug.Print("TaskDialog return: " & EvtTaskDialog.Show(Me, DialogPage).ToString)
    End Sub

    Private Sub EvtTaskDialog_DialogTimer(hDialog As IntPtr, Milliseconds As Integer) Handles EvtTaskDialog.DialogTimer

        EvtTaskDialog.DialogProgressBarValue(Milliseconds \ 100)

        If Milliseconds \ 100 > 101 Then
            EvtTaskDialog.Close()
        Else
            EvtTaskDialog.DialogSetTextElement("Dieser Dialog beendet sich in " & (10 - Milliseconds \ 1000).ToString &
                                               " Sekunden selbst.", TaskDialog.TaskDialogTextElements.Footer)
        End If
    End Sub

    Private Sub Button8_Click(sender As Object, e As EventArgs) Handles Button8.Click

        Dim DialogPage As New TaskDialogPage

        With DialogPage
            .DialogFlags = TaskDialogPage.TaskDialogFlags.UseCommandLinks
            .DialogTitle = "Main Page"
            .DialogContent = "Content"
            .DialogInstruction = "Such Dir eine Option aus..."
            .DialogAddButton = New TaskDialogButton(101, "Option 1")
            .DialogAddButton = New TaskDialogButton(102, "Option 2")
            .DialogCommonMainIcon = TaskDialogPage.TaskDialogIcon.ShieldWarningYellowBar
        End With

        Debug.Print("TaskDialog return: " & PageTaskDialog.Show(Me, DialogPage).ToString)

    End Sub

    Private Sub PageTaskDialog_DialogButtonClicked(hDialog As IntPtr, ButtonID As TaskDialog.TaskDialogResult) Handles PageTaskDialog.DialogButtonClicked

        If ButtonID = 101 Then

            Dim DialogPage1 As New TaskDialogPage

            With DialogPage1
                .DialogFlags = TaskDialogPage.TaskDialogFlags.Default
                .DialogTitle = "Option 1"
                .DialogInstruction = "Das war wohl nix. ;-)"
                .DialogContent = "Content"
                .DialogAddButton = New TaskDialogButton(TaskDialogButton.TaskDialogButtons.TryAgain)
                .DialogCommonMainIcon = TaskDialogPage.TaskDialogIcon.ShieldErrorRedBar
            End With

            PageTaskDialog.DialogNavigateToPage(DialogPage1)

        ElseIf ButtonID = 102 Then

            Dim DialogPage2 As New TaskDialogPage

            With DialogPage2
                .DialogFlags = TaskDialogPage.TaskDialogFlags.Default
                .DialogTitle = "Option 2"
                .DialogInstruction = "Glück gehabt. "
                .DialogContent = "Content"
                .DialogCommonMainIcon = TaskDialogPage.TaskDialogIcon.ShieldSuccessGreenBar
            End With

            PageTaskDialog.DialogNavigateToPage(DialogPage2)

        ElseIf ButtonID = TaskDialog.TaskDialogResult.TryAgain Then

            Dim DialogPage As New TaskDialogPage

            With DialogPage
                .DialogFlags = TaskDialogPage.TaskDialogFlags.UseCommandLinks
                .DialogTitle = "Main Page"
                .DialogInstruction = "Nächster Versuch ..."
                .DialogAddButton = New TaskDialogButton(101, "Option 1")
                .DialogAddButton = New TaskDialogButton(102, "Option 2")
                .DialogCommonMainIcon = TaskDialogPage.TaskDialogIcon.ShieldGrayBar
            End With

            PageTaskDialog.DialogNavigateToPage(DialogPage)

        End If

    End Sub

End Class
